Index: moodle/backup/util/ui/renderer.php
--- moodle/backup/util/ui/renderer.php Base (1.3)
+++ moodle/backup/util/ui/renderer.php Locally Modified (Based On 1.3)
@@ -63,6 +63,182 @@
     public function dependency_notification($message) {
         return html_writer::tag('div', $message, array('class'=>'notification dependencies_enforced'));
     }
+
+    public function backup_details($details, $nextstageurl) {
+        $yestick = $this->output->pix_icon('i/tick_green_big', get_string('yes'));
+        $notick = $this->output->pix_icon('i/cross_red_big', get_string('no'));
+
+        $html  = html_writer::start_tag('div', array('class'=>'backup-restore'));
+
+        $html .= html_writer::start_tag('div', array('class'=>'backup-section'));
+        $html .= $this->output->heading(get_string('backupdetails', 'backup'), 2, array('class'=>'header'));
+        $html .= $this->backup_detail_pair(get_string('backuptype', 'backup'), get_string('backuptype'.$details->type, 'backup'));
+        $html .= $this->backup_detail_pair(get_string('backupformat', 'backup'), get_string('backupformat'.$details->format, 'backup'));
+        $html .= $this->backup_detail_pair(get_string('backupmode', 'backup'), get_string('backupmode'.$details->mode, 'backup'));
+        $html .= $this->backup_detail_pair(get_string('backupdate', 'backup'), userdate($details->backup_date));
+        $html .= $this->backup_detail_pair(get_string('moodleversion', 'backup'), 
+                html_writer::tag('span', $details->moodle_release, array('class'=>'moodle_release')).
+                html_writer::tag('span', '['.$details->moodle_version.']', array('class'=>'moodle_version sub-detail')));
+        $html .= $this->backup_detail_pair(get_string('backupversion', 'backup'),
+                html_writer::tag('span', $details->backup_release, array('class'=>'moodle_release')).
+                html_writer::tag('span', '['.$details->backup_version.']', array('class'=>'moodle_version sub-detail')));
+        $html .= $this->backup_detail_pair(get_string('originalwwwroot', 'backup'),
+                html_writer::tag('span', $details->original_wwwroot, array('class'=>'originalwwwroot')).
+                html_writer::tag('span', '['.$details->original_site_identifier_hash.']', array('class'=>'sitehash sub-detail')));
+        $html .= html_writer::end_tag('div');
+
+        $html .= html_writer::start_tag('div', array('class'=>'backup-section settings-section'));
+        $html .= $this->output->heading(get_string('backupsettings', 'backup'), 2, array('class'=>'header'));
+        foreach ($details->root_settings as $label=>$value) {
+            if ($label == 'filename') continue;
+            $html .= $this->backup_detail_pair(get_string('general'.str_replace('_','',$label), 'backup'), $value?$yestick:$notick);
+        }
+        $html .= html_writer::end_tag('div');
+
+        $html .= html_writer::start_tag('div', array('class'=>'backup-section'));
+        $html .= $this->output->heading(get_string('backupcoursedetails', 'backup'), 2, array('class'=>'header'));
+        $html .= $this->backup_detail_pair(get_string('coursetitle', 'backup'), $details->course->title);
+        $html .= $this->backup_detail_pair(get_string('courseid', 'backup'), $details->course->courseid);
+
+        $html .= html_writer::start_tag('div', array('class'=>'backup-sub-section'));
+        $html .= $this->output->heading(get_string('backupcoursesections', 'backup'), 3, array('class'=>'subheader'));
+        foreach ($details->sections as $key=>$section) {
+            $included = $key.'_included';
+            $userinfo = $key.'_userinfo';
+            if ($section->settings[$included] && $section->settings[$userinfo]) {
+                $value = get_string('sectionincanduser','backup');
+            } else if ($section->settings[$included]) {
+                $value = get_string('sectioninc','backup');
+            } else {
+                continue;
+            }
+            $html .= $this->backup_detail_pair(get_string('backupcoursesection', 'backup', $section->title), $value);
+            $table = null;
+            foreach ($details->activities as $activitykey=>$activity) {
+                if ($activity->sectionid != $section->sectionid) {
+                    continue;
+                }
+                if (empty($table)) {
+                    $table = new html_table();
+                    $table->head = array('Module', 'Title', 'Userinfo');
+                    $table->colclasses = array('modulename', 'moduletitle', 'userinfoincluded');
+                    $table->align = array('left','left', 'center');
+                    $table->attributes = array('class'=>'activitytable generaltable');
+                    $table->data = array();
+                }
+                $table->data[] = array(
+                    get_string('pluginname', $activity->modulename),
+                    $activity->title,
+                    ($activity->settings[$activitykey.'_userinfo'])?$yestick:$notick,
+                );
+            }
+            if (!empty($table)) {
+                $html .= $this->backup_detail_pair(get_string('sectionactivities','backup'), html_writer::table($table));
+            }
+            
+        }
+        $html .= html_writer::end_tag('div');
+        $html .= html_writer::end_tag('div');
+        $html .= html_writer::end_tag('div');
+
+        $html .= $this->output->single_button($nextstageurl, get_string('continue'), 'post');
+
+        return $html;
+    }
+
+    public function course_selector(moodle_url $nextstageurl, $details, $categories, $courses, $currentcourse = null) {
+        global $CFG;
+        require_once($CFG->dirroot.'/course/lib.php');
+
+        $nextstageurl->param('sesskey', sesskey());
+
+        $form = html_writer::start_tag('form', array('method'=>'post', 'action'=>$nextstageurl->out_omit_querystring()));
+        foreach ($nextstageurl->params() as $key=>$value) {
+            $form .= html_writer::empty_tag('input', array('type'=>'hidden', 'name'=>$key, 'value'=>$value));
+        }
+
+        $html  = html_writer::start_tag('div', array('class'=>'backup-course-selector backup-restore'));
+
+        // Current course
+        if (!empty($currentcourse)) {
+            $html .= $form;
+            $form .= html_writer::empty_tag('input', array('type'=>'hidden', 'name'=>'targetid', 'value'=>$currentcourse));
+            $html .= html_writer::start_tag('div', array('class'=>'bcs-current-course backup-section'));
+            $html .= $this->output->heading(get_string('restoretocurrentcourse', 'backup'), 2, array('class'=>'header'));
+            $html .= $this->backup_detail_input(get_string('restoretocurrentcourseadding', 'backup'), 'radio', 'target', backup::TARGET_CURRENT_ADDING);
+            $html .= $this->backup_detail_input(get_string('restoretocurrentcoursedeleting', 'backup'), 'radio', 'target', backup::TARGET_CURRENT_DELETING);
+            $html .= $this->backup_detail_pair('', html_writer::empty_tag('input', array('type'=>'submit', 'value'=>get_string('continue'))));
+            $html .= html_writer::end_tag('div');
+            $html .= html_writer::end_tag('form');
+        }
+
+        // New course
+        $html .= $form;
+        $html .= html_writer::start_tag('div', array('class'=>'bcs-new-course backup-section'));
+        $html .= $this->output->heading(get_string('restoretonewcourse', 'backup'), 2, array('class'=>'header'));
+        $html .= $this->backup_detail_input(get_string('restoretonewcourse', 'backup'), 'radio', 'target', backup::TARGET_NEW_COURSE, array('checked'=>'checked'));
+        $html .= $this->backup_detail_select(get_string('coursecategory', 'backup'), 'targetid', $categories);
+        $html .= $this->backup_detail_pair('', html_writer::empty_tag('input', array('type'=>'submit', 'value'=>get_string('continue'))));
+        $html .= html_writer::end_tag('div');
+        $html .= html_writer::end_tag('form');
+
+        // Existing course
+        $html .= $form;
+        $html .= html_writer::start_tag('div', array('class'=>'bcs-existing-course backup-section'));
+        $html .= $this->output->heading(get_string('restoretoexistingcourse', 'backup'), 2, array('class'=>'header'));
+        $html .= $this->backup_detail_input(get_string('restoretoexistingcourseadding', 'backup'), 'radio', 'target', backup::TARGET_EXISTING_ADDING);
+        $html .= $this->backup_detail_input(get_string('restoretoexistingcoursedeleting', 'backup'), 'radio', 'target', backup::TARGET_EXISTING_DELETING);
+        $html .= $this->backup_detail_select(get_string('restoretocourse', 'backup'), 'targetid', $courses);
+        $html .= $this->backup_detail_pair('', html_writer::empty_tag('input', array('type'=>'submit', 'value'=>get_string('continue'))));
+        $html .= html_writer::end_tag('div');
+        $html .= html_writer::end_tag('form');
+
+        $html .= html_writer::end_tag('div');
+        return $html;
+    }
+
+    protected function backup_detail_pair($label, $value) {
+        static $count= 0;
+        $count++;
+        $html  = html_writer::start_tag('div', array('class'=>'detail-pair'));
+        $html .= html_writer::tag('label', $label, array('class'=>'detail-pair-label', 'for'=>'detail-pair-value-'.$count));
+        $html .= html_writer::tag('div', $value, array('class'=>'detail-pair-value', 'name'=>'detail-pair-value-'.$count));
+        $html .= html_writer::end_tag('div');
+        return $html;
+    }
+
+    protected function backup_detail_input($label, $type, $name, $value, array $attributes=array()) {
+        return $this->backup_detail_pair($label, html_writer::empty_tag('input', $attributes+array('name'=>$name, 'type'=>$type, 'value'=>$value)));
+    }
+
+    protected function backup_detail_select($label, $name, $options, $selected='', $nothing=false, array $attributes=array()) {
+        return $this->backup_detail_pair($label, html_writer::select($options, 'targetid', '', false, $attributes));
+    }
+
+    public function precheck_notices($results) {
+        $output = html_writer::start_tag('div', array('class'=>'restore-precheck-notices'));
+        if (array_key_exists('errors', $results)) {
+            foreach ($results['errors'] as $error) {
+                $output .= $this->output->notification($error);
+            }
+        }
+        if (array_key_exists('warnings', $results)) {
+            foreach ($results['warnings'] as $warning) {
+                $output .= $this->output->notification($warning, 'notifywarning notifyproblem');
+            }
+        }
+        return $output.html_writer::end_tag('div');
+    }
+
+    public function continue_button($url) {
+        if (!($url instanceof moodle_url)) {
+            $url = new moodle_url($url);
+        }
+        $url->param('sesskey', sesskey());
+        $button = new single_button($url, get_string('continue'), 'post');
+        $button->class = 'continuebutton';
+        return $this->render($button);
+    }
     /**
      * Print a backup files tree
      * @param file_info $fileinfo
@@ -113,6 +289,7 @@
         $html .= '</div>';
         return $html;
     }
+    
\ No newline at end of file
 }
 /**
  * Data structure representing backup files viewer
Index: moodle/backup/util/ui/restore_moodleform.class.php
--- moodle/backup/util/ui/restore_moodleform.class.php No Base Revision
+++ moodle/backup/util/ui/restore_moodleform.class.php Locally New
@@ -0,0 +1,13 @@
+<?php
+
+require_once($CFG->dirroot.'/backup/util/ui/backup_moodleform.class.php');
+
+class restore_moodleform extends base_moodleform {
+    public function __construct(restore_ui_stage $uistage, $action = null, $customdata = null, $method = 'post', $target = '', $attributes = null, $editable = true) {
+        parent::__construct($uistage, $action, $customdata, $method, $target, $attributes, $editable);
+    }
+}
+
+class restore_settings_form extends restore_moodleform {}
+class restore_schema_form extends restore_moodleform {}
+class restore_review_form extends restore_moodleform {};
\ No newline at end of file
Index: moodle/backup/util/ui/restore_ui.class.php
--- moodle/backup/util/ui/restore_ui.class.php No Base Revision
+++ moodle/backup/util/ui/restore_ui.class.php Locally New
@@ -0,0 +1,241 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * This file contains the restore user interface class
+ *
+ * @package   moodlecore
+ * @copyright 2010 Sam Hemelryk
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+/**
+ * This is the restore user interface class
+ *
+ * The restore user interface class manages the user interface and restore for
+ * Moodle.
+ *
+ * @copyright 2010 Sam Hemelryk
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+class restore_ui extends base_ui {
+    /**
+     * The stages of the restore user interface.
+     */
+    const STAGE_CONFIRM = 1;
+    const STAGE_DESTINATION = 2;
+    const STAGE_SETTINGS = 4;
+    const STAGE_SCHEMA = 8;
+    const STAGE_REVIEW = 16;
+    const STAGE_PROCESS = 32;
+    const STAGE_COMPLETE = 64;
+
+    /**
+     *
+     * @var restore_ui_stage
+     */
+    protected $stage = null;
+
+    public static $stages = array(
+        restore_ui::STAGE_CONFIRM       => 'confirm',
+        restore_ui::STAGE_DESTINATION   => 'destination',
+        restore_ui::STAGE_SETTINGS      => 'settings',
+        restore_ui::STAGE_SCHEMA        => 'schema',
+        restore_ui::STAGE_REVIEW        => 'review',
+        restore_ui::STAGE_PROCESS       => 'process',
+        restore_ui::STAGE_COMPLETE      => 'complete'
+    );
+    /**
+     * Intialises what ever stage is requested. If none are requested we check
+     * params for 'stage' and default to initial
+     *
+     * @param int|null $stage The desired stage to intialise or null for the default
+     * @return restore_ui_stage_initial|restore_ui_stage_schema|restore_ui_stage_confirmation|restore_ui_stage_final
+     */
+    protected function initialise_stage($stage = null, array $params=null) {
+        if ($stage == null) {
+            $stage = optional_param('stage', self::STAGE_CONFIRM, PARAM_INT);
+        }
+        $class = 'restore_ui_stage_'.self::$stages[$stage];
+        if (!class_exists($class)) {
+            throw new restore_ui_exception('unknownuistage');
+        }
+        $stage = new $class($this, $params);
+        return $stage;
+    }
+    /**
+     * This processes the current stage of the restore
+     * @return bool
+     */
+    public function process() {
+        if ($this->progress >= self::PROGRESS_PROCESSED) {
+            throw new restore_ui_exception('restoreuialreadyprocessed');
+        }
+        $this->progress = self::PROGRESS_PROCESSED;
+
+        if (optional_param('previous', false, PARAM_BOOL) && $this->stage->get_stage() > self::STAGE_CONFIRM) {
+            $this->stage = $this->initialise_stage($this->stage->get_prev_stage(), $this->stage->get_params());
+            return false;
+        }
+
+        // Process the stage
+        $processoutcome = $this->stage->process();
+        if ($processoutcome !== false && !($this->get_stage()==self::STAGE_PROCESS && optional_param('substage', false, PARAM_BOOL))) {
+            $this->stage = $this->initialise_stage($this->stage->get_next_stage(), $this->stage->get_params());
+        }
+
+        // Process UI event after to check changes are valid
+        $this->controller->process_ui_event();
+        return $processoutcome;
+    }
+
+    public function is_independent() {
+        return false;
+    }
+    /**
+     * @return string
+     */
+    public function get_uniqueid() {
+        return $this->get_restoreid();
+    }
+    /**
+     * Gets the restore id from the controller
+     * @return string
+     */
+    public function get_restoreid() {
+        return $this->controller->get_restoreid();
+    }
+    /**
+     * Executes the restore plan
+     * @return bool
+     */
+    public function execute() {
+        if ($this->progress >= self::PROGRESS_EXECUTED) {
+            throw new restore_ui_exception('restoreuialreadyexecuted');
+        }
+        if ($this->stage->get_stage() < self::STAGE_PROCESS) {
+            throw new restore_ui_exception('restoreuifinalisedbeforeexecute');
+        }
+        if ($this->controller->get_target() == backup::TARGET_CURRENT_DELETING || $this->controller->get_target() == backup::TARGET_EXISTING_DELETING) {
+            restore_dbops::delete_course_content($this->controller->get_courseid());
+        }
+        $this->controller->execute_plan();
+        $this->progress = self::PROGRESS_EXECUTED;
+        $this->stage = new restore_ui_stage_complete($this, $this->stage->get_params(), $this->controller->get_results());
+        return true;
+    }
+    /**
+     * Returns true if enforce_dependencies changed any settings
+     * @return bool
+     */
+    public function enforce_changed_dependencies() {
+        return ($this->dependencychanges > 0);
+    }
+    /**
+     * Loads the restore controller if we are tracking one
+     * @return restore_controller|false
+     */
+    final public static function load_controller($restoreid=false) {
+        // Get the restore id optional param
+        if ($restoreid) {
+            try {
+                // Try to load the controller with it.
+                // If it fails at this point it is likely because this is the first load
+                $controller = restore_controller::load_controller($restoreid);
+                return $controller;
+            } catch (Exception $e) {
+                return false;
+            }
+        }
+        return $restoreid;
+    }
+    final public static function engage_independent_stage($stage, $contextid) {
+        if (!($stage & self::STAGE_CONFIRM + self::STAGE_DESTINATION)) {
+            throw new restore_ui_exception('dependentstagerequested');
+        }
+        $class = 'restore_ui_stage_'.self::$stages[$stage];
+        if (!class_exists($class)) {
+            throw new restore_ui_exception('unknownuistage');
+        }
+        return new $class($contextid);
+    }
+    /**
+     * Cancels the current restore and redirects the user back to the relevant place
+     */
+    public function cancel_restore() {
+        global $PAGE;
+        // Determine the approriate URL to redirect the user to
+        if ($PAGE->context->contextlevel == CONTEXT_MODULE && $PAGE->cm !== null) {
+            $relevanturl = new moodle_url('/mod/'.$PAGE->cm->modname.'/view.php', array('id'=>$PAGE->cm->id));
+        } else {
+            $relevanturl = new moodle_url('/course/view.php', array('id'=>$PAGE->course->id));
+        }
+        redirect($relevanturl);
+    }
+    /**
+     * Gets an array of progress bar items that can be displayed through the restore renderer.
+     * @return array Array of items for the progress bar
+     */
+    public function get_progress_bar() {
+        global $PAGE;
+
+        $stage = self::STAGE_COMPLETE;
+        $currentstage = $this->stage->get_stage();
+        $items = array();
+        while ($stage > 0) {
+            $classes = array('backup_stage');
+            if (floor($stage/2) == $currentstage) {
+                $classes[] = 'backup_stage_next';
+            } else if ($stage == $currentstage) {
+                $classes[] = 'backup_stage_current';
+            } else if ($stage < $currentstage) {
+                $classes[] = 'backup_stage_complete';
+            }
+            $item = array('text' => strlen(decbin($stage)).'. '.get_string('restorestage'.$stage, 'backup'),'class' => join(' ', $classes));
+            if ($stage < $currentstage && $currentstage < self::STAGE_COMPLETE && $stage > self::STAGE_DESTINATION) {
+                $item['link'] = new moodle_url($PAGE->url, array('restore'=>$this->get_restoreid(), 'stage'=>$stage));
+            }
+            array_unshift($items, $item);
+            $stage = floor($stage/2);
+        }
+        return $items;
+    }
+
+    public function get_name() {
+        return 'restore';
+    }
+
+    public function get_first_stage_id() {
+        return self::STAGE_CONFIRM;
+    }
+
+    public function requires_substage() {
+        return ($this->stage->has_sub_stages() && !$this->stage->process());
+    }
+
+    public function display($renderer) {
+        if ($this->progress < self::PROGRESS_SAVED) {
+            throw new base_ui_exception('backupsavebeforedisplay');
+        }
+        $this->stage->display($renderer);
+    }
+}
+
+/**
+ * restore user interface exception. Modelled off the restore_exception class
+ */
+class restore_ui_exception extends base_ui_exception {}
\ No newline at end of file
